#include <windows.h>
#include <shlwapi.h>
#include "ProfileIO.h"

CProfileIO::CProfileIO()
{
	m_init = false;
}

CProfileIO::CProfileIO(LPCSTR profile)
{
	m_init = false;
	Initialize(profile);
}

BOOL CProfileIO::Initialize(LPCSTR profile_name)
{
	if(m_init)
		return TRUE;
	// inipX𐶐
	GetModuleFileName(NULL, m_profile_path, sizeof(m_profile_path));
	PathRemoveFileSpec(m_profile_path);
	PathAppend(m_profile_path, profile_name);
	m_init = TRUE;

	return TRUE;
}

DWORD CProfileIO::ReadString(LPCSTR sec, LPCSTR key, LPCSTR def, LPSTR buf, DWORD len)
{
	if(!m_init)
		return -1;
	return GetPrivateProfileString(sec, key, def, buf, len, m_profile_path);
}

UINT CProfileIO::ReadInteger(LPCSTR sec, LPCSTR key, INT def)
{
	if(!m_init)
		return -1;
	return GetPrivateProfileInt(sec, key, def, m_profile_path);
}

DWORD CProfileIO::WriteString(LPCSTR sec, LPCSTR key, LPSTR value)
{
	if(!m_init)
		return -1;
	return WritePrivateProfileString(sec, key, value, m_profile_path);
}

DWORD CProfileIO::WriteInteger(LPCSTR sec, LPCSTR key, INT value)
{
	char buf[16];
	if(!m_init)
		return -1;
	itoa(value, buf, 10);
	return WritePrivateProfileString(sec, key, buf, m_profile_path);
}

