#pragma once
struct DirectDraw7;
class DirectDrawClipper;
class DirectDrawPallete;
class DirectDrawColorControl;
class DirectDrawGammaControl;
class DirectDrawPalette;
class Direct3D7;
class DirectDrawEnumSurfaces;
class DirectDrawIdentifier;
class DirectDrawEnumModes;

struct VBDDBLTFX;

typedef enum {
	vbDDLOCK_SURFACEMEMORYPTR = 0,
	vbDDLOCK_WAIT = 1,
	vbDDLOCK_EVENT = 2,
	vbDDLOCK_READONLY = 16,
	vbDDLOCK_WRITEONLY = 32,
	vbDDLOCK_NOSYSLOCK = 2048,
	vbDDLOCK_DONOTWAIT = 16384
} CONST_DDLOCKFLAGS;

typedef enum {
	vbDDPCAPS_4BIT = 1,
	vbDDPCAPS_8BITENTRIES = 2,
	vbDDPCAPS_8BIT = 4,
	vbDDPCAPS_INITIALIZE = 8,
	vbDDPCAPS_PRIMARYSURFACE = 16,
	vbDDPCAPS_PRIMARYSURFACELEFT = 32,
	vbDDPCAPS_ALLOW256 = 64,
	vbDDPCAPS_VSYNC = 128,
	vbDDPCAPS_1BIT = 256,
	vbDDPCAPS_2BIT = 512,
	vbDDPCAPS_ALPHA = 1024
} CONST_DDPCAPSFLAGS;

typedef enum {
	vbDDEDM_DEFAULT = 0,
	vbDDEDM_REFRESHRATES = 1,
	vbDDEDM_STANDARDVGAMODES = 2
} CONST_DDEDMFLAGS;

typedef enum {
	vbDDSCL_FULLSCREEN = 1,
	vbDDSCL_ALLOWREBOOT = 2,
	vbDDSCL_NOWINDOWCHANGES = 4,
	vbDDSCL_NORMAL = 8,
	vbDDSCL_EXCLUSIVE = 16,
	vbDDSCL_ALLOWMODEX = 64,
	vbDDSCL_CREATEDEVICEWINDOW = 512,
	vbDDSCL_MULTITHREADED = 1024,
	vbDDSCL_SETDEVICEWINDOW = 256,
	vbDDSCL_SETFOCUSWINDOW = 128
} CONST_DDSCLFLAGS;

typedef enum {
	vbDDSDM_DEFAULT = 0,
	vbDDSDM_STANDARDVGAMODE = 1
} CONST_DDSDMFLAGS;

typedef enum {
	vbDDBLT_ASYNC = 512,
	vbDDBLT_COLORFILL = 1024,
	vbDDBLT_DDFX = 2048,
	vbDDBLT_DDROPS = 4096,
	vbDDBLT_KEYDEST = 8192,
	vbDDBLT_KEYDESTOVERRIDE = 16384,
	vbDDBLT_KEYSRC = 32768,
	vbDDBLT_KEYSRCOVERRIDE = 0x00010000,
	vbDDBLT_ROP = 0x00020000,
	vbDDBLT_ROTATIONANGLE = 0x00040000,
	vbDDBLT_WAIT = 0x01000000,
	vbDDBLT_DEPTHFILL = 0x02000000,
	vbDDBLT_DONOTWAIT = 0x08000000
} CONST_DDBLTFLAGS;

typedef enum {
	vbDDBLTFAST_NOCOLORKEY = 0,
	vbDDBLTFAST_SRCCOLORKEY = 1,
	vbDDBLTFAST_DESTCOLORKEY = 2,
	vbDDBLTFAST_WAIT = 16,
	vbDDBLTFAST_DONOTWAIT = 32
} CONST_DDBLTFASTFLAGS;

typedef enum {
	vbDDFLIP_WAIT = 1,
	vbDDFLIP_EVEN = 2,
	vbDDFLIP_ODD = 4,
	vbDDFLIP_NOVSYNC = 8,
	vbDDFLIP_STEREO = 16,
	vbDDFLIP_DONOTWAIT = 32,
	vbDDFLIP_INTERFVAL2 = 0x20000000,
	vbDDFLIP_INTERFVAL3 = 0x30000000,
	vbDDFLIP_INTERFVAL4 = 0x40000000
} CONST_DDFLIPFLAGS;

typedef enum {
	vbDDENUMOVERLAYZ_BACKTOFRONT = 0,
	vbDDENUMOVERLAYZ_FRONTTOBACK = 1
} CONST_DDENUMOVERLAYZFLAGS;

typedef enum {
	vbDDOVER_ALPHADEST = 1,
	vbDDOVER_ALPHADESTCONSTOVERRIDE = 2,
	vbDDOVER_ALPHADESTNEG = 4,
	vbDDOVER_ALPHADESTSURFACEOVERRIDE = 8,
	vbDDOVER_ALPHAEDGEBLEND = 16,
	vbDDOVER_ALPHASRC = 32,
	vbDDOVER_ALPHASRCCONSTOVERRIDE = 64,
	vbDDOVER_ALPHASRCNEG = 128,
	vbDDOVER_ALPHASRCSURFACEOVERRIDE = 256,
	vbDDOVER_HIDE = 512,
	vbDDOVER_KEYDEST = 1024,
	vbDDOVER_KEYDESTOVERRIDE = 2048,
	vbDDOVER_KEYSRC = 4096,
	vbDDOVER_KEYSRCOVERRIDE = 8192,
	vbDDOVER_SHOW = 16384,
	vbDDOVER_ADDDIRTYRECT = 32768,
	vbDDOVER_REFRESHDIRTYRECTS = 0x00010000,
	vbDDOVER_REFRESHALL = 0x00020000,
	vbDDOVER_DDFX = 0x00080000,
	vbDDOVER_AUTOFLIP = 0x00100000,
	vbDDOVER_BOB = 0x00200000,
	vbDDOVER_OVERRIDEBOBWEAVE = 0x00400000,
	vbDDOVER_INTERLEAVED = 0x00800000,
	vbDDOVER_ARGBSCALEFACTORS = 0x02000000,
	vbDDOVER_DEGRADEARGBSCALING = 0x04000000
} CONST_DDOVERFLAGS;

typedef enum {
	vbDDOVERZ_SENDTOFRONT = 0,
	vbDDOVERZ_SENDTOBACK = 1,
	vbDDOVERZ_MOVEFORWARD = 2,
	vbDDOVERZ_MOVEBACKWARD = 3,
	vbDDOVERZ_INSERTINFRONTOF = 4,
	vbDDOVERZ_INSERTINBACKOF = 5
} CONST_DDOVERZFLAGS;

typedef enum {
	vbDDGFS_CANFLIP = 1,
	vbDDGFS_ISFLIPDONE = 2
} CONST_DDGFSFLAGS;

typedef enum {
	vbDDGBS_CANBLT = 1,
	vbDDGBS_ISBLTDONE = 2
} CONST_DDGBSFLAGS;

typedef enum {
	vbDDCKEY_COLORSPACE = 1,
	vbDDCKEY_DESTBLT = 2,
	vbDDCKEY_DESTOVERLAY = 4,
	vbDDCKEY_SRCBLT = 8,
	vbDDCKEY_SRCOVERLAY = 16
} CONST_DDCKEYFLAGS;

typedef enum {
	vbDDSGR_DEFAULT = 0,
	vbDDSGR_CALIBRATE = 1
} CONST_DDSGRFLAGS;

typedef enum {
	D_FALSE = 0,
	D_TRUE = 1
} CONST_DBOOLFLAGS;

typedef enum {
	vbDDBD_1 = 16384,
	vbDDBD_2 = 8192,
	vbDDBD_4 = 4096,
	vbDDBD_8 = 2048,
	vbDDBD_16 = 1024,
	vbDDBD_24 = 512,
	vbDDBD_32 = 256
} CONST_DDBITDEPTHFLAGS;

typedef enum {
	vbDDSD_CAPS = 1,
	vbDDSD_HEIGHT = 2,
	vbDDSD_WIDTH = 4,
	vbDDSD_PITCH = 8,
	vbDDSD_BACKBUFFERCOUNT = 32,
	vbDDSD_ZBUFFERBITDEPTH = 64,
	vbDDSD_ALPHABITDEPTH = 128,
	vbDDSD_TEXTURESTAGE = 0x00100000,
	vbDDSD_LPSURFACE = 2048,
	vbDDSD_PIXELFORMAT = 4096,
	vbDDSD_CKDESTOVERLAY = 8192,
	vbDDSD_CKDESTBLT = 16384,
	vbDDSD_CKSRCOVERLAY = 32768,
	vbDDSD_CKSRCBLT = 0x00010000,
	vbDDSD_MIPMAPCOUNT = 0x00020000,
	vbDDSD_REFRESHRATE = 0x00040000,
	vbDDSD_LINEARSIZE = 0x00080000,
	vbDDSD_ALL = 0x000ff9ee
} CONST_DDSURFACEDESCFLAGS;

typedef enum {
	vbDDCOLOR_BRIGHTNESS = 1,
	vbDDCOLOR_CONTRAST = 2,
	vbDDCOLOR_HUE = 4,
	vbDDCOLOR_SATURATION = 8,
	vbDDCOLOR_SHARPNESS = 16,
	vbDDCOLOR_GAMMA = 32,
	vbDDCOLOR_COLORENABLE = 64
} CONST_DDCOLORFLAGS;

typedef enum {
	vbDDSCAPS_ALPHA = 2,
	vbDDSCAPS_BACKBUFFER = 4,
	vbDDSCAPS_COMPLEX = 8,
	vbDDSCAPS_FLIP = 16,
	vbDDSCAPS_FRONTBUFFER = 32,
	vbDDSCAPS_OFFSCREENPLAIN = 64,
	vbDDSCAPS_OVERLAY = 128,
	vbDDSCAPS_PALETTE = 256,
	vbDDSCAPS_PRIMARYSURFACE = 512,
	vbDDSCAPS_PRIMARYSURFACELEFT = 1024,
	vbDDSCAPS_SYSTEMMEMORY = 2048,
	vbDDSCAPS_TEXTURE = 4096,
	vbDDSCAPS_3DDEVICE = 8192,
	vbDDSCAPS_VIDEOMEMORY = 16384,
	vbDDSCAPS_VISIBLE = 32768,
	vbDDSCAPS_WRITEONLY = 0x00010000,
	vbDDSCAPS_ZBUFFER = 0x00020000,
	vbDDSCAPS_OWNDC = 0x00040000,
	vbDDSCAPS_LIVEVIDEO = 0x00080000,
	vbDDSCAPS_HWCODEC = 0x00100000,
	vbDDSCAPS_MODEX = 0x00200000,
	vbDDSCAPS_MIPMAP = 0x00400000,
	vbDDSCAPS_RESERVED2 = 0x00800000,
	vbDDSCAPS_ALLOCONLOAD = 0x04000000,
	vbDDSCAPS_VIDEOPORT = 0x08000000,
	vbDDSCAPS_LOCALVIDMEM = 0x10000000,
	vbDDSCAPS_NONLOCALVIDMEM = 0x20000000,
	vbDDSCAPS_STANDARDVGAMODE = 0x40000000,
	vbDDSCAPS_OPTIMIZED = 0x80000000
} CONST_DDSURFACECAPSFLAGS;

typedef enum {
	vbDDSCAPS2_HARDWAREDEINTERLACE = 2,
	vbDDSCAPS2_HINTDYNAMIC = 4,
	vbDDSCAPS2_HINTSTATIC = 8,
	vbDDSCAPS2_TEXTUREMANAGE = 16,
	vbDDSCAPS2_OPAQUE = 128,
	vbDDSCAPS2_HINTANTIALIASING = 256,
	vbDDSCAPS2_CUBEMAP = 512,
	vbDDSCAPS2_CUBEMAP_POSITIVEX = 1024,
	vbDDSCAPS2_CUBEMAP_NEGATIVEX = 2048,
	vbDDSCAPS2_CUBEMAP_POSITIVEY = 4096,
	vbDDSCAPS2_CUBEMAP_NEGATIVEY = 8192,
	vbDDSCAPS2_CUBEMAP_POSITIVEZ = 16384,
	vbDDSCAPS2_CUBEMAP_NEGATIVEZ = 32768,
	vbDDSCAPS2_CUBEMAP_ALLFACES = 65024,
	vbDDSCAPS2_MIPMAPSUBLEVEL = 0x00010000,
	vbDDSCAPS2_D3DTEXTUREMANAGE = 0x00020000,
	vbDDSCAPS2_STEREOSURFACELEFT = 0x00080000
} CONST_DDSURFACECAPS2FLAGS;

typedef enum {
	vbDDCAPS_3D = 1,
	vbDDCAPS_ALIGNBOUNDARYDEST = 2,
	vbDDCAPS_ALIGNSIZEDEST = 4,
	vbDDCAPS_ALIGNBOUNDARYSRC = 8,
	vbDDCAPS_ALIGNSIZESRC = 16,
	vbDDCAPS_ALIGNSTRIDE = 32,
	vbDDCAPS_BLT = 64,
	vbDDCAPS_BLTQUEUE = 128,
	vbDDCAPS_BLTFOURCC = 256,
	vbDDCAPS_BLTSTRETCH = 512,
	vbDDCAPS_GDI = 1024,
	vbDDCAPS_OVERLAY = 2048,
	vbDDCAPS_OVERLAYCANTCLIP = 4096,
	vbDDCAPS_OVERLAYFOURCC = 8192,
	vbDDCAPS_OVERLAYSTRETCH = 16384,
	vbDDCAPS_PALETTE = 32768,
	vbDDCAPS_PALETTEVSYNC = 0x00010000,
	vbDDCAPS_READSCANLINE = 0x00020000,
	vbDDCAPS_STEREOVIEW = 0x00040000,
	vbDDCAPS_VBI = 0x00080000,
	vbDDCAPS_ZBLTS = 0x00100000,
	vbDDCAPS_ZOVERLAYS = 0x00200000,
	vbDDCAPS_COLORKEY = 0x00400000,
	vbDDCAPS_ALPHA = 0x00800000,
	vbDDCAPS_COLORKEYHWASSIST = 0x01000000,
	vbDDCAPS_NOHARDWARE = 0x02000000,
	vbDDCAPS_BLTCOLORFILL = 0x04000000,
	vbDDCAPS_BANKSWITCHED = 0x08000000,
	vbDDCAPS_BLTDEPTHFILL = 0x10000000,
	vbDDCAPS_CANCLIP = 0x20000000,
	vbDDCAPS_CANCLIPSTRETCHED = 0x40000000,
	vbDDCAPS_CANBLTSYSMEM = 0x80000000
} CONST_DDCAPS1FLAGS;

typedef enum {
	vbDDCAPS2_CERTIFIED = 1,
	vbDDCAPS2_NO2DDURING3DSCENE = 2,
	vbDDCAPS2_VIDEOPORT = 4,
	vbDDCAPS2_AUTOFLIPOVERLAY = 8,
	vbDDCAPS2_CANBOBINTERLEAVED = 16,
	vbDDCAPS2_CANBOBNONINTERLEAVED = 32,
	vbDDCAPS2_COLORCONTROLOVERLAY = 64,
	vbDDCAPS2_COLORCONTROLPRIMARY = 128,
	vbDDCAPS2_CANDROPZ16BIT = 256,
	vbDDCAPS2_NONLOCALVIDMEM = 512,
	vbDDCAPS2_NONLOCALVIDMEMCAPS = 1024,
	vbDDCAPS2_NOPAGELOCKREQUIRED = 2048,
	vbDDCAPS2_WIDESURFACES = 4096,
	vbDDCAPS2_CANFLIPODDEVEN = 8192,
	vbDDCAPS2_CANBOBHARDWARE = 16384,
	vbDDCAPS2_COPYFOURCC = 32768,
	vbDDCAPS2_PRIMARYGAMMA = 0x00020000,
	vbDDCAPS2_CANRENDERWINDOWED = 0x00080000,
	vbDDCAPS2_CANCALIBRATEGAMMA = 0x00100000,
	vbDDCAPS2_FLIPINTERVAL = 0x00200000,
	vbDDCAPS2_FLIPNOVSYNC = 0x00400000,
	vbDDCAPS2_CANMANAGETEXTURE = 0x00800000,
	vbDDCAPS2_STEREO = 0x02000000
} CONST_DDCAPS2FLAGS;

typedef enum {
	vbDDFXCAPS_BLTARITHSTRETCHY = 32,
	vbDDFXCAPS_BLTARITHSTRETCHYN = 16,
	vbDDFXCAPS_BLTMIRRORLEFTRIGHT = 64,
	vbDDFXCAPS_BLTMIRRORUPDOWN = 128,
	vbDDFXCAPS_BLTROTATION = 256,
	vbDDFXCAPS_BLTROTATION90 = 512,
	vbDDFXCAPS_BLTSHRINKX = 1024,
	vbDDFXCAPS_BLTSHRINKXN = 2048,
	vbDDFXCAPS_BLTSHRINKY = 4096,
	vbDDFXCAPS_BLTSHRINKYN = 8192,
	vbDDFXCAPS_BLTSTRETCHX = 16384,
	vbDDFXCAPS_BLTSTRETCHXN = 32768,
	vbDDFXCAPS_BLTSTRETCHY = 0x00010000,
	vbDDFXCAPS_BLTSTRETCHYN = 0x00020000,
	vbDDFXCAPS_OVERLAYARITHSTRETCHY = 0x00040000,
	vbDDFXCAPS_OVERLAYARITHSTRETCHYN = 8,
	vbDDFXCAPS_OVERLAYSHRINKX = 0x00080000,
	vbDDFXCAPS_OVERLAYSHRINKXN = 0x00100000,
	vbDDFXCAPS_OVERLAYSHRINKY = 0x00200000,
	vbDDFXCAPS_OVERLAYSHRINKYN = 0x00400000,
	vbDDFXCAPS_OVERLAYSTRETCHX = 0x00800000,
	vbDDFXCAPS_OVERLAYSTRETCHXN = 0x01000000,
	vbDDFXCAPS_OVERLAYSTRETCHY = 0x02000000,
	vbDDFXCAPS_OVERLAYSTRETCHYN = 0x04000000,
	vbDDFXCAPS_OVERLAYMIRRORLEFTRIGHT = 0x08000000,
	vbDDFXCAPS_OVERLAYMIRRORUPDOWN = 0x10000000,
	vbDDFXCAPS_BLTALPHA = 1,
	vbDDFXCAPS_BLTTRANSFORM = 2,
	vbDDFXCAPS_BLTFILTER = 32,
	vbDDFXCAPS_OVERLAYALPHA = 4,
	vbDDFXCAPS_OVERLAYTRANSFORM = 0x20000000,
	vbDDFXCAPS_OVERLAYFILTER = 0x00040000
} CONST_DDFXCAPSFLAGS;

typedef enum {
	vbDDSVCAPS_ENIGMA = 1,
	vbDDSVCAPS_FLICKER = 2,
	vbDDSVCAPS_REDBLUE = 4,
	vbDDSVCAPS_SPLIT = 8,
	vbDDSVCAPS_STEREOSEQUENTIAL = 16
} CONST_DDSTEREOCAPSFLAGS;

typedef enum {
	vbDDCKEYCAPS_DESTBLT = 1,
	vbDDCKEYCAPS_DESTBLTCLRSPACE = 2,
	vbDDCKEYCAPS_DESTBLTCLRSPACEYUV = 4,
	vbDDCKEYCAPS_DESTBLTYUV = 8,
	vbDDCKEYCAPS_DESTOVERLAY = 16,
	vbDDCKEYCAPS_DESTOVERLAYCLRSPACE = 32,
	vbDDCKEYCAPS_DESTOVERLAYCLRSPACEYUV = 64,
	vbDDCKEYCAPS_DESTOVERLAYONEACTIVE = 128,
	vbDDCKEYCAPS_DESTOVERLAYYUV = 256,
	vbDDCKEYCAPS_SRCBLT = 512,
	vbDDCKEYCAPS_SRCBLTCLRSPACE = 1024,
	vbDDCKEYCAPS_SRCBLTCLRSPACEYUV = 2048,
	vbDDCKEYCAPS_SRCBLTYUV = 4096,
	vbDDCKEYCAPS_SRCOVERLAY = 8192,
	vbDDCKEYCAPS_SRCOVERLAYCLRSPACE = 16384,
	vbDDCKEYCAPS_SRCOVERLAYCLRSPACEYUV = 32768,
	vbDDCKEYCAPS_SRCOVERLAYONEACTIVE = 0x00010000,
	vbDDCKEYCAPS_SRCOVERLAYYUV = 0x00020000,
	vbDDCKEYCAPS_NOCOSTOVERLAY = 0x00040000
} CONST_DDCKEYCAPSFLAGS;

typedef enum {
	vbDDPF_ALPHAPIXELS = 1,
	vbDDPF_ALPHA = 2,
	vbDDPF_FOURCC = 4,
	vbDDPF_PALETTEINDEXED4 = 8,
	vbDDPF_PALETTEINDEXEDTO8 = 16,
	vbDDPF_PALETTEINDEXED8 = 32,
	vbDDPF_RGB = 64,
	vbDDPF_COMPRESSED = 128,
	vbDDPF_RGBTOYUV = 256,
	vbDDPF_YUV = 512,
	vbDDPF_ZBUFFER = 1024,
	vbDDPF_PALETTEINDEXED1 = 2048,
	vbDDPF_PALETTEINDEXED2 = 4096,
	vbDDPF_ZPIXELS = 8192,
	vbDDPF_STENCILBUFFER = 16384,
	vbDDPF_ALPHAPREMULT = 32768,
	vbDDPF_LUMINANCE = 0x00020000,
	vbDDPF_BUMPLUMINANCE = 0x00040000,
	vbDDPF_BUMPDUDV = 0x00080000
} CONST_DDPIXELFORMATFLAGS;

typedef enum {
	vbDDENUMSURFACES_ALL = 1,
	vbDDENUMSURFACES_MATCH = 2,
	vbDDENUMSURFACES_NOMATCH = 4,
	vbDDENUMSURFACES_CANBECREATED = 8,
	vbDDENUMSURFACES_DOESEXIST = 16
} CONST_DDENUMSURFACESFLAGS;

typedef enum {
	vbDD_ROP_SPACE = 8
} CONST_DDRAW;

typedef enum {
	vbDDBLTFX_ARITHSTRETCHY = 1,
	vbDDBLTFX_MIRRORLEFTRIGHT = 2,
	vbDDBLTFX_MIRRORUPDOWN = 4,
	vbDDBLTFX_NOTEARING = 8,
	vbDDBLTFX_ROTATE180 = 16,
	vbDDBLTFX_ROTATE270 = 32,
	vbDDBLTFX_ROTATE90 = 64,
	vbDDBLTFX_ZBUFFERRANGE = 128,
	vbDDBLTFX_ZBUFFERBASEDEST = 256
} CONST_DDBLTFXFLAGS;

typedef enum {
	vbDDWAITVB_BLOCKBEGIN = 1,
	vbDDWAITVB_BLOCKBEGINEVENT = 2,
	vbDDWAITVB_BLOCKEND = 4
} CONST_DDWAITVBFLAGS;

typedef enum {
	DIEDFL_ALLDEVICES = 0,
	DIEDFL_ATTACHEDONLY = 1,
	DIEDFL_FORCEFEEDBACK = 256,
	DIEDFL_INCLUDEALIASES = 0x00010000,
	DIEDFL_INCLUDEPHANTOMS = 0x00020000
} CONST_DIENUMDEVICESFLAGS;

typedef enum {
	DIDEVTYPE_DEVICE = 1,
	DIDEVTYPE_MOUSE = 2,
	DIDEVTYPE_KEYBOARD = 3,
	DIDEVTYPE_JOYSTICK = 4,
	DIDEVTYPE_HID = 0x00010000,
	DIDEVTYPEMOUSE_UNKNOWN = 256,
	DIDEVTYPEMOUSE_TRADITIONAL = 512,
	DIDEVTYPEMOUSE_FINGERSTICK = 768,
	DIDEVTYPEMOUSE_TOUCHPAD = 1024,
	DIDEVTYPEMOUSE_TRACKBALL = 1280,
	DIDEVTYPEKEYBOARD_UNKNOWN = 0,
	DIDEVTYPEKEYBOARD_PCXT = 256,
	DIDEVTYPEKEYBOARD_OLIVETTI = 512,
	DIDEVTYPEKEYBOARD_PCAT = 768,
	DIDEVTYPEKEYBOARD_PCENH = 1024,
	DIDEVTYPEKEYBOARD_NOKIA1050 = 1280,
	DIDEVTYPEKEYBOARD_NOKIA9140 = 1536,
	DIDEVTYPEKEYBOARD_NEC98 = 1792,
	DIDEVTYPEKEYBOARD_NEC98LAPTOP = 2048,
	DIDEVTYPEKEYBOARD_NEC98106 = 2304,
	DIDEVTYPEKEYBOARD_JAPAN106 = 2560,
	DIDEVTYPEKEYBOARD_JAPANAX = 2816,
	DIDEVTYPEKEYBOARD_J3100 = 3072,
	DIDEVTYPEJOYSTICK_UNKNOWN = 256,
	DIDEVTYPEJOYSTICK_TRADITIONAL = 512,
	DIDEVTYPEJOYSTICK_FLIGHTSTICK = 768,
	DIDEVTYPEJOYSTICK_GAMEPAD = 1024,
	DIDEVTYPEJOYSTICK_RUDDER = 1280,
	DIDEVTYPEJOYSTICK_WHEEL = 1536,
	DIDEVTYPEJOYSTICK_HEADTRACKER = 1792
} CONST_DIDEVICETYPE;


typedef enum {
	PC_DEFAULT_ = 0,
	PC_RESERVED_ = 1,
	PC_EXPLICIT_ = 2,
	PC_NOCOLLAPSE_ = 4
} CONST_DDPALFLAGS;

typedef enum {
	vbDDGDI_DEFAULT = 0,
	vbDDGDI_GETHOSTIDENTIFIER = 1
} CONST_DDDEVICEIDFLAGS;

typedef enum {
	vbDDOVERFX_ARITHSTRETCHY = 1,
	vbDDOVERFX_MIRRORLEFTRIGHT = 2,
	vbDDOVERFX_MIRRORUPDOWN = 4
} CONST_DDOVERFXFLAGS;

typedef struct tagDDCOLORKEY {
	long low;
	long high;
} VBDDCOLORKEY;

typedef struct tagDDSCAPS2 {
	CONST_DDSURFACECAPSFLAGS lCaps;
	CONST_DDSURFACECAPS2FLAGS lCaps2;
	long lCaps3;
	long lCaps4;
} VBDDSCAPS2;

typedef struct tagDDPIXELFORMAT {
	long lSize;
	CONST_DDPIXELFORMATFLAGS lFlags;
	long lFourCC;
	long internalVal1;
	long internalVal2;
	long internalVal3;
	long internalVal4;
	long internalVal5;
	long lRGBBitCount;
	long lYUVBitCount;
	long lZBufferBitDepth;
	long lAlphaBitDepth;
	long lLuminanceBitCount;
	long lBumpBitCount;
	long lRBitMask;
	long lYBitMask;
	long lStencilBitDepth;
	long lLuminanceBitMask;
	long lBumpDuBitMask;
	long lGBitMask;
	long lUBitMask;
	long lZBitMask;
	long lBumpDvBitMask;
	long lBBitMask;
	long lVBitMask;
	long lStencilBitMask;
	long lBumpLuminanceBitMask;
	long lRGBAlphaBitMask;
	long lYUVAlphaBitMask;
	long lLuminanceAlphaBitMask;
	long lRGBZBitMask;
	long lYUVZBitMask;
} VBDDPIXELFORMAT;

typedef struct tagDDSURFACEDESC2 {
	long lSize;
	CONST_DDSURFACEDESCFLAGS lFlags;
	long lHeight;
	long lWidth;
	long lPitch;
	long lBackBufferCount;
	long lZBufferBitDepth;
	long lAlphaBitDepth;
	long lReserved;
	long lpSurface;
	VBDDCOLORKEY ddckCKDestOverlay;
	VBDDCOLORKEY ddckCKDestBlt;
	VBDDCOLORKEY ddckCKSrcOverlay;
	VBDDCOLORKEY ddckCKSrcBlt;
	VBDDPIXELFORMAT ddpfPixelFormat;
	VBDDSCAPS2 ddsCaps;
	long lTextureStage;
	long lLinearSize;
	long lMipMapCount;
	long lRefreshRate;
} VBDDSURFACEDESC2;

typedef struct tagDDCAPS {    
	long lSize;
	CONST_DDCAPS1FLAGS lCaps;
	CONST_DDCAPS2FLAGS lCaps2;
	CONST_DDCKEYCAPSFLAGS lCKeyCaps;
	CONST_DDFXCAPSFLAGS lFXCaps;
	long lFXAlphaCaps;
	CONST_DDPCAPSFLAGS lPalCaps;
	CONST_DDSTEREOCAPSFLAGS lSVCaps;
	long lAlphaBltConstBitDepths;
	long lAlphaBltPixelBitDepths;
	long lAlphaBltSurfaceBitDepths;
	long lAlphaOverlayConstBitDepths;
	long lAlphaOverlayPixelBitDepths;
	long lAlphaOverlaySurfaceBitDepths;
	long lZBufferBitDepths;
	long lVidMemTotal;
	long lVidMemFree;
	long lMaxVisibleOverlays;
	long lCurrVisibleOverlays;
	long lNumFourCCCodes;
	long lAlignBoundarySrc;
	long lAlignSizeSrc;
	long lAlignBoundaryDest;
	long lAlignSizeDest;
	long lAlignStrideAlign;
	long lRops[8];
	long lReservedCaps;
	long lMinOverlayStretch;
	long lMaxOverlayStretch;
	long lMinLiveVideoStretch;
	long lMaxLiveVideoStretch;
	long lMinHwCodecStretch;
	long lMaxHwCodecStretch;
	long lReserved1;
	long lReserved2;
	long lReserved3;
	CONST_DDCAPS1FLAGS lSVBCaps;
	CONST_DDCKEYCAPSFLAGS lSVBCKeyCaps;
	CONST_DDFXCAPSFLAGS lSVBFXCaps;
	long lSVBRops[8];
	CONST_DDCAPS1FLAGS lVSBCaps;
	CONST_DDCKEYCAPSFLAGS lVSBCKeyCaps;
	CONST_DDFXCAPSFLAGS lVSBFXCaps;
	long lVSRops[8];
	CONST_DDCAPS1FLAGS lSSBCaps;
	CONST_DDCKEYCAPSFLAGS lSSBCKeyCaps;
	CONST_DDFXCAPSFLAGS lSSBFXCaps;
	long lSSBRops[8];
	long lMaxVideoPorts;
	long lCurrVideoPorts;
	CONST_DDCAPS2FLAGS lSVBCaps2;
	CONST_DDCAPS1FLAGS lNLVBCaps;
	CONST_DDCAPS2FLAGS lNLVBCaps2;
	CONST_DDCKEYCAPSFLAGS lNLVBCKeyCaps;
	CONST_DDFXCAPSFLAGS lNLVBFXCaps;
	long lNLVBRops[8];
	VBDDSCAPS2 ddsCaps;
} VBDDCAPS;

typedef struct tagDDOVERLAYFX {
	long lSize;
	long lAlphaEdgeBlendBitDepth;
	long lAlphaEdgeBlend;
	long lReserved;
	long lAlphaDestConstBitDepth;
	long lAlphaDestConst;
	long lAlphaSrcConstBitDepth;
	long lAlphaSrcConst;
	VBDDCOLORKEY dckDestColorkey;
	VBDDCOLORKEY dckSrcColorkey;
	CONST_DDOVERFXFLAGS lDDFX;
	long lFlags;
} VBDDOVERLAYFX;

MIDL_INTERFACE("9F76FDE8-8E92-11D1-8808-00C04FC2C602")
DirectDrawSurface7 : public IUnknown {
    /* [hidden] */
    virtual HRESULT _stdcall InternalSetObject(/* [in] */ IUnknown* lpdds) = 0;
    /* [hidden] */
    virtual HRESULT _stdcall InternalGetObject(/* [out, retval] */ IUnknown** lpdds) = 0;
    /* [helpcontext(0x0004aa89)] */
    virtual HRESULT _stdcall AddAttachedSurface(/* [in] */ DirectDrawSurface7* ddS) = 0;
    /* [helpcontext(0x0004aa8a)] */
    virtual HRESULT _stdcall Blt(
                    /* [in] */ RECT* destRect, 
                    /* [in] */ DirectDrawSurface7* ddS, 
                    /* [in] */ RECT* srcRect, 
                    /* [in] */ CONST_DDBLTFLAGS flags, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aa8b)] */
    virtual HRESULT _stdcall BltColorFill(
                    /* [in] */ RECT* destRect, 
                    /* [in] */ long fillvalue, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aa8c)] */
    virtual HRESULT _stdcall BltFast(
                    /* [in] */ long dx, 
                    /* [in] */ long dy, 
                    /* [in] */ DirectDrawSurface7* ddS, 
                    /* [in] */ RECT* srcRect, 
                    /* [in] */ CONST_DDBLTFASTFLAGS trans, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aa8d)] */
    virtual HRESULT _stdcall BltFx(
                    /* [in] */ RECT* destRect, 
                    /* [in] */ DirectDrawSurface7* ddS, 
                    /* [in] */ RECT* srcRect, 
                    /* [in] */ CONST_DDBLTFLAGS flags, 
                    /* [in] */ VBDDBLTFX* BltFx, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aa8e)] */
    virtual HRESULT _stdcall BltToDC(
                    /* [in] */ long hdc, 
                    /* [in] */ RECT* srcRect, 
                    /* [in] */ RECT* destRect) = 0;
    /* [helpcontext(0x0004aa8f)] */
    virtual HRESULT _stdcall ChangeUniquenessValue() = 0;
    /* [helpcontext(0x0004aa90)] */
    virtual HRESULT _stdcall DeleteAttachedSurface(/* [in] */ DirectDrawSurface7* ddS) = 0;
    /* [helpcontext(0x0004aa91)] */
    virtual HRESULT _stdcall DrawBox(
                    /* [in] */ long x1, 
                    /* [in] */ long y1, 
                    /* [in] */ long x2, 
                    /* [in] */ long y2) = 0;
    /* [helpcontext(0x0004aa92)] */
    virtual HRESULT _stdcall DrawCircle(
                    /* [in] */ long x1, 
                    /* [in] */ long y1, 
                    /* [in] */ long r) = 0;
    /* [helpcontext(0x0004aa93)] */
    virtual HRESULT _stdcall DrawEllipse(
                    /* [in] */ long x1, 
                    /* [in] */ long y1, 
                    /* [in] */ long x2, 
                    /* [in] */ long y2) = 0;
    /* [helpcontext(0x0004aa94)] */
    virtual HRESULT _stdcall DrawLine(
                    /* [in] */ long x1, 
                    /* [in] */ long y1, 
                    /* [in] */ long x2, 
                    /* [in] */ long y2) = 0;
    /* [helpcontext(0x0004aa95)] */
    virtual HRESULT _stdcall DrawRoundedBox(
                    /* [in] */ long x1, 
                    /* [in] */ long y1, 
                    /* [in] */ long x2, 
                    /* [in] */ long y2, 
                    /* [in] */ long rw, 
                    /* [in] */ long rh) = 0;
    /* [helpcontext(0x0004aa96)] */
    virtual HRESULT _stdcall DrawText(
                    /* [in] */ long x, 
                    /* [in] */ long y, 
                    /* [in] */ BSTR text, 
                    /* [in] */ VARIANT_BOOL b) = 0;
    /* [helpcontext(0x0004aa97)] */
    virtual HRESULT _stdcall Flip(
                    /* [in] */ DirectDrawSurface7* ddS, 
                    /* [in] */ CONST_DDFLIPFLAGS flags) = 0;
    /* [helpcontext(0x0004aa98)] */
    virtual HRESULT _stdcall GetAttachedSurface(
                    /* [in] */ VBDDSCAPS2* caps, 
                    /* [out, retval] */ DirectDrawSurface7** ddS) = 0;
    /* [helpcontext(0x0004aa99)] */
    virtual HRESULT _stdcall GetAttachedSurfaceEnum(/* [out, retval] */ DirectDrawEnumSurfaces** retval) = 0;
    /* [helpcontext(0x0004aa9a)] */
    virtual HRESULT _stdcall GetBltStatus(
                    /* [in] */ CONST_DDGFSFLAGS flags, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aa9b)] */
    virtual HRESULT _stdcall GetCaps(/* [in, out] */ VBDDSCAPS2* caps) = 0;
    /* [helpcontext(0x0004aa9c)] */
    virtual HRESULT _stdcall GetClipper(/* [out, retval] */ DirectDrawClipper** val) = 0;
    /* [helpcontext(0x0004aa9d)] */
    virtual HRESULT _stdcall GetColorKey(
                    /* [in] */ long flags, 
                    /* [in, out] */ VBDDCOLORKEY* val) = 0;
    /* [helpcontext(0x0004aa9e)] */
    virtual HRESULT _stdcall GetDC(/* [out, retval] */ long* hdc) = 0;
    /* [helpcontext(0x0004aa9f)] */
    virtual HRESULT _stdcall GetDirectDraw(/* [out, retval] */ DirectDraw7** val) = 0;
    /* [helpcontext(0x0004aaa0)] */
    virtual HRESULT _stdcall GetDirectDrawColorControl(/* [out, retval] */ DirectDrawColorControl** retV) = 0;
    /* [helpcontext(0x0004aaa1)] */
    virtual HRESULT _stdcall GetDirectDrawGammaControl(/* [out, retval] */ DirectDrawGammaControl** retV) = 0;
    /* [helpcontext(0x0004aaa2)] */
    virtual HRESULT _stdcall getDrawStyle(/* [out, retval] */ long* drawStyle) = 0;
    /* [helpcontext(0x0004aaa3)] */
    virtual HRESULT _stdcall getDrawWidth(/* [out, retval] */ long* drawWidth) = 0;
    /* [helpcontext(0x0004aaa4)] */
    virtual HRESULT _stdcall GetFillColor(/* [out, retval] */ long* color) = 0;
    /* [helpcontext(0x0004aaa5)] */
    virtual HRESULT _stdcall GetFillStyle(/* [out, retval] */ long* fillStyle) = 0;
    /* [helpcontext(0x0004aaa6)] */
    virtual HRESULT _stdcall GetFlipStatus(
                    /* [in] */ CONST_DDGFSFLAGS flags, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aaa7)] */
    virtual HRESULT _stdcall GetFontTransparency(/* [out, retval] */ VARIANT_BOOL* b) = 0;
    /* [helpcontext(0x0004aaa8)] */
    virtual HRESULT _stdcall GetForeColor(/* [out, retval] */ long* color) = 0;
    /* [helpcontext(0x0004aaa9)] */
    virtual HRESULT _stdcall GetLockedPixel(
                    /* [in] */ int x, 
                    /* [in] */ int y, 
                    /* [out, retval] */ long* col) = 0;
    /* [helpcontext(0x0004aaab)] */
    virtual HRESULT _stdcall GetPalette(/* [out, retval] */ DirectDrawPalette** val) = 0;
    /* [helpcontext(0x0004aaac)] */
    virtual HRESULT _stdcall GetPixelFormat(/* [in, out] */ VBDDPIXELFORMAT* pf) = 0;
    /* [helpcontext(0x0004aaad)] */
    virtual HRESULT _stdcall GetSurfaceDesc(/* [in, out] */ VBDDSURFACEDESC2* surface) = 0;
    /* [helpcontext(0x0004aaae)] */
    virtual HRESULT _stdcall GetUniquenessValue(/* [out, retval] */ long* retval) = 0;
    /* [helpcontext(0x0004aaaf)] */
    virtual HRESULT _stdcall isLost(/* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004aab0)] */
    virtual HRESULT _stdcall Lock(
                    /* [in] */ RECT* r, 
                    /* [in] */ VBDDSURFACEDESC2* desc, 
                    /* [in] */ CONST_DDLOCKFLAGS flags, 
                    /* [in] */ long hnd) = 0;
    /* [helpcontext(0x0004aab1)] */
    virtual HRESULT _stdcall ReleaseDC(/* [in] */ long hdc) = 0;
    /* [helpcontext(0x0004aab2)] */
    virtual HRESULT _stdcall restore() = 0;
    /* [helpcontext(0x0004aab3)] */
    virtual HRESULT _stdcall SetClipper(/* [in] */ DirectDrawClipper* val) = 0;
    /* [helpcontext(0x0004aab4)] */
    virtual HRESULT _stdcall SetColorKey(
                    /* [in] */ CONST_DDCKEYFLAGS flags, 
                    /* [in] */ VBDDCOLORKEY* val) = 0;
    /* [helpcontext(0x0004aab5)] */
    virtual HRESULT _stdcall setDrawStyle(/* [in] */ long drawStyle) = 0;
    /* [helpcontext(0x0004aab6)] */
    virtual HRESULT _stdcall setDrawWidth(/* [in] */ long drawWidth) = 0;
    /* [helpcontext(0x0004aab7)] */
    virtual HRESULT _stdcall SetFillColor(/* [in] */ long color) = 0;
    /* [helpcontext(0x0004aab8)] */
    virtual HRESULT _stdcall SetFillStyle(/* [in] */ long fillStyle) = 0;
    /* [helpcontext(0x0004aab9)] */
    virtual HRESULT _stdcall SetFont(/* [in] */ IFont* font) = 0;
    /* [helpcontext(0x0004aaba)] */
    virtual HRESULT _stdcall SetFontTransparency(/* [in] */ VARIANT_BOOL b) = 0;
    /* [helpcontext(0x0004aabb)] */
    virtual HRESULT _stdcall SetForeColor(/* [in] */ long color) = 0;
    /* [helpcontext(0x0004aabc)] */
    virtual HRESULT _stdcall SetLockedPixel(
                    /* [in] */ int x, 
                    /* [in] */ int y, 
                    /* [in] */ long col) = 0;
    /* [helpcontext(0x0004aabe)] */
    virtual HRESULT _stdcall SetPalette(/* [in] */ DirectDrawPalette* ddp) = 0;
    /* [helpcontext(0x0004aabf)] */
    virtual HRESULT _stdcall Unlock(/* [in] */ RECT* r) = 0;
    /* [helpcontext(0x0004aac0)] */
    virtual HRESULT _stdcall SetPriority(/* [in] */ long priority) = 0;
    /* [helpcontext(0x0004aac1)] */
    virtual HRESULT _stdcall GetPriority(/* [out, retval] */ long* priority) = 0;
    /* [helpcontext(0x0004aac2)] */
    virtual HRESULT _stdcall GetLOD(/* [out, retval] */ long* lod) = 0;
    /* [helpcontext(0x0004aac3)] */
    virtual HRESULT _stdcall SetLOD(/* [in] */ long lod) = 0;
    /* [helpcontext(0x0004aac4)] */
    virtual HRESULT _stdcall GetLockedArray(/* [in] */ SAFEARRAY(unsigned char)* array) = 0;
    /* [helpcontext(0x0004aacc)] */
    virtual HRESULT _stdcall SetFontBackColor(/* [in] */ long color) = 0;
    /* [helpcontext(0x0004aacd)] */
    virtual HRESULT _stdcall GetFontBackColor(/* [out, retval] */ long* color) = 0;
    /* [helpcontext(0x0004aace)] */
    virtual HRESULT _stdcall UpdateOverlay(
                    /* [in] */ RECT* rect, 
                    /* [in] */ DirectDrawSurface7* ddS, 
                    /* [in] */ RECT* rectD, 
                    /* [in] */ CONST_DDOVERFLAGS flags) = 0;
    /* [helpcontext(0x0004aacf)] */
    virtual HRESULT _stdcall UpdateOverlayZOrder(
                    /* [in] */ CONST_DDOVERZFLAGS flags, 
                    /* [in] */ DirectDrawSurface7* ddS) = 0;
    /* [helpcontext(0x0004aad0)] */
    virtual HRESULT _stdcall GetOverlayPosition(
                    /* [in, out] */ long* x, 
                    /* [in, out] */ long* y) = 0;
    /* [helpcontext(0x0004aad1)] */
    virtual HRESULT _stdcall SetOverlayPosition(
                    /* [in] */ long x, 
                    /* [in] */ long y) = 0;
    /* [helpcontext(0x0004aad2)] */
    virtual HRESULT _stdcall GetOverlayZOrdersEnum(
                    /* [in] */ CONST_DDENUMOVERLAYZFLAGS flags, 
                    /* [out, retval] */ DirectDrawEnumSurfaces** retval) = 0;
    /* [helpcontext(0x0004aad3)] */
    virtual HRESULT _stdcall UpdateOverlayFx(
                    /* [in] */ RECT* rect, 
                    /* [in] */ DirectDrawSurface7* ddS, 
                    /* [in] */ RECT* rectD, 
                    /* [in] */ CONST_DDOVERFLAGS flags, 
                    /* [in, out] */ VBDDOVERLAYFX* ddoverfx) = 0;
};

MIDL_INTERFACE("9F76FDE7-8E92-11D1-8808-00C04FC2C602")
DirectDraw7 : public IUnknown {
    /* [hidden] */
    virtual HRESULT _stdcall InternalSetObject(/* [in] */ IUnknown* lpdd) = 0;
    /* [hidden] */
    virtual HRESULT _stdcall InternalGetObject(/* [out, retval] */ IUnknown** lpdd) = 0;
    /* [helpcontext(0x0004a9c1)] */
    virtual HRESULT _stdcall CreateClipper(
                    /* [in] */ long flags, 
                    /* [out, retval] */ DirectDrawClipper** val) = 0;
    /* [helpcontext(0x0004a9c2)] */
    virtual HRESULT _stdcall CreatePalette(
                    /* [in] */ CONST_DDPCAPSFLAGS flags, 
                    /* [in] */ SAFEARRAY(PALETTEENTRY) * pe, 
                    /* [out, retval] */ DirectDrawPalette** val) = 0;
    /* [helpcontext(0x0004a9c3)] */
    virtual HRESULT _stdcall CreateSurface(
                    /* [in] */ VBDDSURFACEDESC2* dd, 
                    /* [out, retval] */ DirectDrawSurface7** retV) = 0;
    /* [helpcontext(0x0004a9c4)] */
    virtual HRESULT _stdcall CreateSurfaceFromFile(
                    /* [in] */ BSTR file, 
                    /* [in, out] */ VBDDSURFACEDESC2* dd, 
                    /* [out, retval] */ DirectDrawSurface7** retV) = 0;
    /* [helpcontext(0x0004a9c5)] */
    virtual HRESULT _stdcall CreateSurfaceFromResource(
                    /* [in] */ BSTR file, 
                    /* [in] */ BSTR resName, 
                    /* [in, out] */ VBDDSURFACEDESC2* ddsd, 
                    /* [out, retval] */ DirectDrawSurface7** retV) = 0;
    /* [helpcontext(0x0004a9c6)] */
    virtual HRESULT _stdcall DuplicateSurface(
                    /* [in] */ DirectDrawSurface7* ddIn, 
                    /* [out, retval] */ DirectDrawSurface7** ddOut) = 0;
    /* [helpcontext(0x0004a9c7)] */
    virtual HRESULT _stdcall FlipToGDISurface() = 0;
    /* [helpcontext(0x0004a9c8)] */
    virtual HRESULT _stdcall GetAvailableTotalMem(
                    /* [in] */ VBDDSCAPS2* ddsCaps, 
                    /* [out, retval] */ long* m) = 0;
    /* [helpcontext(0x0004a9c9)] */
    virtual HRESULT _stdcall GetCaps(
                    /* [in, out] */ VBDDCAPS* hwCaps, 
                    /* [in, out] */ VBDDCAPS* helCaps) = 0;
    /* [helpcontext(0x0004a9ca)] */
    virtual HRESULT _stdcall GetDirect3D(/* [out, retval] */ Direct3D7** retV) = 0;
    /* [helpcontext(0x0004a9cb)] */
    virtual HRESULT _stdcall GetDisplayMode(/* [in, out] */ VBDDSURFACEDESC2* surface) = 0;
    /* [helpcontext(0x0004a9cc)] */
    virtual HRESULT _stdcall GetDisplayModesEnum(
                    /* [in] */ CONST_DDEDMFLAGS flags, 
                    /* [in] */ VBDDSURFACEDESC2* ddsd, 
                    /* [out, retval] */ DirectDrawEnumModes** retval) = 0;
    /* [helpcontext(0x0004a9cd)] */
    virtual HRESULT _stdcall GetFourCCCodes(/* [in, out] */ SAFEARRAY(long)* ccCodes) = 0;
    /* [helpcontext(0x0004a9ce)] */
    virtual HRESULT _stdcall GetFreeMem(
                    /* [in] */ VBDDSCAPS2* ddsCaps, 
                    /* [out, retval] */ long* m) = 0;
    /* [helpcontext(0x0004a9cf)] */
    virtual HRESULT _stdcall GetGDISurface(/* [out, retval] */ DirectDrawSurface7** s) = 0;
    /* [helpcontext(0x0004a9d0)] */
    virtual HRESULT _stdcall GetMonitorFrequency(/* [out, retval] */ long* freq) = 0;
    /* [helpcontext(0x0004a9d1)] */
    virtual HRESULT _stdcall GetNumFourCCCodes(/* [out, retval] */ long* nCodes) = 0;
    /* [helpcontext(0x0004a9d2)] */
    virtual HRESULT _stdcall GetScanLine(
                    /* [in, out] */ long* lines, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004a9d3)] */
    virtual HRESULT _stdcall GetSurfaceFromDC(
                    /* [in] */ long hdc, 
                    /* [out, retval] */ DirectDrawSurface7** retV) = 0;
    /* [helpcontext(0x0004a9d4)] */
    virtual HRESULT _stdcall GetSurfacesEnum(
                    /* [in] */ CONST_DDENUMSURFACESFLAGS flags, 
                    /* [in] */ VBDDSURFACEDESC2* desc, 
                    /* [out, retval] */ DirectDrawEnumSurfaces** ret) = 0;
    /* [helpcontext(0x0004a9d5)] */
    virtual HRESULT _stdcall GetVerticalBlankStatus(/* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004a9d6)] */
    virtual HRESULT _stdcall LoadPaletteFromBitmap(
                    /* [in] */ BSTR bName, 
                    /* [out, retval] */ DirectDrawPalette** retV) = 0;
    /* [helpcontext(0x0004a9d7)] */
    virtual HRESULT _stdcall RestoreAllSurfaces() = 0;
    /* [helpcontext(0x0004a9d8)] */
    virtual HRESULT _stdcall RestoreDisplayMode() = 0;
    /* [helpcontext(0x0004a9d9)] */
    virtual HRESULT _stdcall SetCooperativeLevel(
                    /* [in] */ long hdl, 
                    /* [in] */ CONST_DDSCLFLAGS flags) = 0;
    /* [helpcontext(0x0004a9da)] */
    virtual HRESULT _stdcall SetDisplayMode(
                    /* [in] */ long w, 
                    /* [in] */ long h, 
                    /* [in] */ long bpp, 
                    /* [in] */ long ref, 
                    /* [in] */ CONST_DDSDMFLAGS mode) = 0;
    /* [helpcontext(0x0004a9db)] */
    virtual HRESULT _stdcall TestCooperativeLevel(/* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004a9dc)] */
    virtual HRESULT _stdcall WaitForVerticalBlank(
                    /* [in] */ CONST_DDWAITVBFLAGS flags, 
                    /* [in] */ long handle, 
                    /* [out, retval] */ long* status) = 0;
    /* [helpcontext(0x0004a9dd)] */
    virtual HRESULT _stdcall GetDeviceIdentifier(
                    /* [in] */ CONST_DDDEVICEIDFLAGS flags, 
                    /* [out, retval] */ DirectDrawIdentifier** ret) = 0;
};
